Bug 114084 - mii-tool returns incorrect link status on 3c90x NIC
mii-tool returns incorrect link status on 3c90x NIC
Product: Fedora
Classification: Fedora
Component: net-tools (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Radek Vokal
Ben Levenson
Depends On:
  Show dependency treegraph
Reported: 2004-01-22 09:51 EST by Ben Lentz
Modified: 2007-11-30 17:10 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2004-11-21 14:54:07 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Ben Lentz 2004-01-22 09:51:19 EST
From Bugzilla Helper:
User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET 
CLR 1.1.4322)

Description of problem:
mii_tool does not properly detect the link status of my 3c90x PCI 
card in a Dell Dimension V400. 

When /etc/rc.d/init.d/network brings up eth0 (DHCP-3c90x) and 
calls /sbin/ifup, which calls the check_link_down function 
in /etc/sysconfig/network-scripts/network-functions, which (finally) 
calls the check_mii_tool function. 

This function returns the results of mii_tool eth0, which contains 
the grepped string 'no link' -- This return code is false. To prove 
it as such, I've been able to workaround this problem by modifying 
the check_mii_tool function to always return an exit status of '1', 
and have been successful in getting the interface up, retrieving a 
DHCP address, and going merrily about my business. No link indeed!

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. Execute 'mii_tool eth0'
2. Observe the return text 'no link', despite the blinky-blinky of 
the NIC.

Actual Results:  mii_tool returns 'no link'.

Expected Results:  mii_tool should return 'link ok'.

Additional info:

Unfortunately, my particular hardware platform may be the only place 
this problem can be reproduced. I understand any reluctance to look 
deep into this problem should it prove to be unreproducable.
Comment 1 wire 2004-03-17 14:58:46 EST
I have this same issue. P120 machine with 2 3c905 PCI cards. Not only
does mii_tool report no link. But using it to set the mode and duplex
is  broken as well. Looks to be something specific with the 3C90x
family of cards and this particular version of mii_tool. Older
versions of the tool work fine (have not tried them on core1 but they
do work under older versions of redhat.)  

Comment 2 Daniel Walsh 2004-04-06 19:31:00 EDT
I can't even find the mii_tool?  What is it?

Comment 3 Peter van Egdom 2004-04-07 06:44:57 EDT
[root@peanut root]# which mii-tool

[root@peanut root]# mii-tool -v
eth0: negotiated 100baseTx-FD flow-control, link ok
  product info: vendor 00:10:5a, model 0 rev 0
  basic mode:   autonegotiation enabled
  basic status: autonegotiation complete, link ok
  capabilities: 100baseTx-FD 100baseTx-HD 10baseT-FD 10baseT-HD
  advertising:  100baseTx-FD 100baseTx-HD 10baseT-FD 10baseT-HD
  link partner: 100baseTx-FD 100baseTx-HD 10baseT-FD 10baseT-HD

[root@peanut root]# rpm -qfi /sbin/mii-tool
Name        : net-tools                    Relocations: (not relocatable)
Version     : 1.60                              Vendor: Red Hat, Inc.
Release     : 23                            Build Date: di 23 mrt 2004
15:54:53 CET
Install Date: do 01 apr 2004 22:08:10 CEST      Build Host:
Group       : System Environment/Base       Source RPM:
Size        : 644173                           License: GPL
Signature   : DSA/SHA1, di 23 mrt 2004 17:02:00 CET, Key ID
Packager    : Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>
Summary     : Basic networking tools.
Description :
The net-tools package contains basic networking tools, including
ifconfig, netstat, route, and others.

ps... maybe the component of this Bugzilla report should be changed to
Comment 4 Daniel Walsh 2004-04-07 07:09:46 EDT
Boy do I feel like and idiot.  For some reason slocate did not return
it.  I will move bug to net-tools
Comment 5 Radek Vokal 2004-08-17 05:11:11 EDT
Ben, wire

 may I have more info about your sw and hardware. Kernel and net-tools
versions etc.
Comment 6 Ben Lentz 2004-08-17 09:06:24 EDT
I don't believe I have the system running any more. I'm pretty sure 
it was net-tools and kernel-2.4.22-1.2188.nptl. The system 
is a Dell Dimension V400 (but this issue also effects the XPS T600r) 
when used with a 3Com 3c905B-TX PCI 10/100 NIC. I've looked through 
the archives and I believe this has been an issue in the past, up to 
and including Red Hat 6.2.

At the moment, I do have a system that is working when querying a 
3c905 card in an older Dimension, but it has a later kernel version 
of kernel-2.4.22-1.2199.ntpl. So... this may be a kernel problem 
rather than a net-tools/mii-tool problem and it may already be fixed. 

It would be handy to cross-reference this with what wire has 
experienced, though. Perhaps a kernel upgrade will resolve this?
Comment 7 Radek Vokal 2004-11-21 14:54:07 EST
Anyway mii-tool is obsolete, I recommend you using ethtool which
supports new NICs.

Note You need to log in before you can comment on or make changes to this bug.